/* Wrapper for automatic c64 packing using VICE/CCS and any of these packers:
   No-Stack-Using Cruncher
   BYG compactor
   TSB packer
   Idiots packer
   Gpacker wrapper
   RowsCruncher
   XTC Packer

 -=[iAN CooG/ex-HokutoForce]=-
02/04/04 1st version , NSU only
??/04/04 added BYG & IDT
10/10/04 modified to run also in XP
21/05/06 added Gpacker
18/02/09 adapted to new vice 2.x parameters
23/03/11 added RowsCruncher/RCC
28/11/11 added XTC Packer 2.4 (2.2+autosave)

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <windows.h>
//#pragma function( strcat ) // prolly needed in mvsc

#define DISKSIZE 174848
#define FILE(x)  (GetFileAttributes(x)!=-1L)

int p2d(int argc, char **argv);
int d2p(int argc, char **argv);
char execstr[1024]={0};
char imgname[]="_temp_.d64";
char IniName[_MAX_PATH];

#include "_nsu.h"
#include "_byg.h"
#include "_tsb.h"
#include "_idt.h"
#include "_gpk.h"
#include "_row.h"
#include "_xtc.h"
#include "d642prg.c"
#include "prg2d64.c"

struct packd
{
    char ID[4];
    char desc[40];
    char filename[8];
    int  patchoffs;
    unsigned char *binary;
    int  binlen;
    BOOL TrueDriveNeeded;
} ;

struct packd packers[]=
{ { "NSU" ,"No-stack-using 1.1 (Crisp/Action)"   , "nsu.prg", NSUOFFSET, nsubin, sizeof(nsubin),TRUE }
, { "BYG" ,"BYG Compactor+ (Naf/Babygang)"       , "byg.prg", BYGOFFSET, bygbin, sizeof(bygbin),TRUE }
, { "TSB" ,"TSB charpacker (TSB/Browbeat)"       , "tsb.prg", TSBOFFSET, tsbbin, sizeof(tsbbin),FALSE}
, { "IDT" ,"FX Bytepacker 2.1 (Laysoft/Idiots)"  , "idt.prg", IDTOFFSET, idtbin, sizeof(idtbin),FALSE}
, { "GPK" ,"G-Packer 1.0 (Graham/Oxyron)"        , "gpk.prg", GPKOFFSET, gpkbin, sizeof(gpkbin),TRUE }
, { "ROW" ,"RowsCruncher (RCC/Spirit)"           , "row.prg", ROWOFFSET, rowbin, sizeof(rowbin),FALSE}
, { "XTC" ,"XTC packer 2.4 (Rockstar/XTC)"       , "xtc.prg", XTCOFFSET, xtcbin, sizeof(xtcbin),FALSE}
};

unsigned char dir[]={
0x12,0x01,0x41,0x00,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,
0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,
0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,
0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,
0x15,0xFF,0xFF,0x1F,0x15,0xFF,0xFF,0x1F,0x11,0xFC,0xFF,0x07,0x13,0xFF,0xFF,0x07,
0x13,0xFF,0xFF,0x07,0x13,0xFF,0xFF,0x07,0x13,0xFF,0xFF,0x07,0x13,0xFF,0xFF,0x07,
0x13,0xFF,0xFF,0x07,0x12,0xFF,0xFF,0x03,0x12,0xFF,0xFF,0x03,0x12,0xFF,0xFF,0x03,
0x12,0xFF,0xFF,0x03,0x12,0xFF,0xFF,0x03,0x12,0xFF,0xFF,0x03,0x11,0xFF,0xFF,0x01,
0x11,0xFF,0xFF,0x01,0x11,0xFF,0xFF,0x01,0x11,0xFF,0xFF,0x01,0x11,0xFF,0xFF,0x01,
0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,
0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0x00,0x00,0x00,0x00,0x00
};

int selectedpacker=-1;


/*****************************************************************************/
int gendisk(void)
/*****************************************************************************/
{
FILE *hdisk;
char *diskimage;

diskimage=calloc(DISKSIZE,1);
memcpy(diskimage+0x16500,dir,sizeof(dir));
diskimage[0x16601]=0xffu;
hdisk=fopen(imgname,"wb");
if(hdisk)
{
    fwrite(diskimage,1,DISKSIZE,hdisk);
    fclose(hdisk);
    hdisk=fopen(packers[selectedpacker].filename,"wb");
    if(hdisk)
    {
        fwrite(packers[selectedpacker].binary,1,packers[selectedpacker].binlen,hdisk);
        fclose(hdisk);
        free(diskimage);
        return 0;
    }
}
free(diskimage);
return 1;

}

/*****************************************************************************/
int GetIniString(char *KeyName, char *ReturnedString, int sizeret)
/*****************************************************************************/
{

char AppName[]="Multi Packer Wrapper";
char Default[]="";
int retval;
WritePrivateProfileString(NULL, NULL, NULL, IniName); // force reread of ini file
retval=GetPrivateProfileString(
 AppName,                   // section name
 KeyName,                   // key name
 Default,                   // default string
 ReturnedString,            // destination buffer
 sizeret,                   // size of destination buffer
 IniName                    // initialization file name
 );
CharUpperBuff(ReturnedString,strlen(ReturnedString));
return retval;
}

/*****************************************************************************/
int c64Str2int(char *C64address)
/*****************************************************************************/
{
    int nbytes2;
    char tempbuf[16];
    if(C64address[0]=='0' && ((C64address[1])&0xdf) =='X')
    {
       nbytes2=strtol(C64address,NULL,16);
    }
    else if(C64address[0]=='$')
    {
      strcpy(tempbuf,"0x");
      strncat(tempbuf,C64address+1,4);
      nbytes2=strtol(tempbuf,NULL,16);
    }
    else
      nbytes2=strtol(C64address,NULL,10);

    nbytes2&=0xffff;
    return nbytes2;
}
/*****************************************************************************/
void listids(char *argv)
/*****************************************************************************/
{
    int i;
    char *p;
    p=strrchr(argv,'\\');
    if(p)
        strcpy(execstr,p+1);
    else
        strcpy(execstr,argv);
    p=strrchr(execstr,'.');
    if(p)
        *p=0;
    CharUpperBuff(execstr,strlen(execstr));

    printf("Usage:\r\n");
    printf("%s [packerID] [input.prg] [output.prg] [($)sysaddres]\r\n",execstr);
    printf("\r\nPackerIDs available:\r\n");
    for(i=0; i< (sizeof( packers ) / sizeof(*packers));i++)
        printf("%s: %s\r\n",packers[i].ID,packers[i].desc);
    printf("(all modified by iAN CooG to work w/o user interaction)\r\n\r\n");
    printf("What is needed\r\n");
    printf("%s.INI   - in the same path as %s.EXE\r\n",execstr,execstr);
    printf("X64.EXE     - WinVice Emulator\r\n");
    printf(" or\r\n");
    printf("CCS.EXE     - CCS Emulator\r\n");
    printf("C64save.CFG - CCS config file, to ensure $DISKSAVEMODE=2 (needed)\r\n");

}

/*****************************************************************************/
int main(int argc, char *argv[])
/*****************************************************************************/
{

char cfgpath[_MAX_PATH]={0};
char ccspath[_MAX_PATH]={0};
char curdir[_MAX_PATH]={0};
char emutype[4]={0};
char *p;
int nbytes;
FILE *hdisk;
char *myargv[4];

STARTUPINFO StartupInfo;
PROCESS_INFORMATION procinfo;

printf("\r\n"
       "Multi Packer Wrapper v2.15                  by -=[iAN CooG/HVSC]=-\r\n");
printf("==================================================================\r\n");
if(argc<5)
{
    listids(argv[0]);
    return 1;
}
for(nbytes=0;nbytes < (sizeof( packers ) / sizeof(*packers));nbytes++)
{
    if(strnicmp(argv[1],packers[nbytes].ID,3)==0)
    {
        selectedpacker = nbytes;
        break;
    }
}
if(selectedpacker<0)
{
    listids(argv[0]);
    return 1;
}
if(GetModuleFileName(NULL,IniName,sizeof(IniName)))
{
    p=strrchr(IniName,'.');
    if(p)
    {
        *p=0;
        strcat(IniName,".INI");
    }
    if(!FILE(IniName))
    {
        printf("%s not found\r\n",IniName);
        return 1;
    }
    *emutype='\0';
    GetIniString("EMUType",emutype,sizeof(emutype));
    if(*emutype)
    {
        *emutype&=0xdf;
        if(!( *emutype == 'C' || *emutype == 'V') )
        {
            *emutype='\0';
        }
    }
    if(!*emutype)
    {
        printf("Invalid %s setting, specify CCS or VICE\r\n","EMUType");
        return 1;
    }
    if(*emutype=='C')
    {
        GetIniString("CFGPath",cfgpath,sizeof(cfgpath));
        if(!FILE(cfgpath))
        {
            printf("Invalid %s setting, \"%s\" does not exist\r\n","CFGPath",cfgpath);
            return 1;
        }

        GetIniString("CCSPath",ccspath,sizeof(ccspath));
        if(!FILE(ccspath))
        {
            printf("Invalid %s setting, \"%s\" does not exist\r\n","CCSPath",ccspath);
            return 1;
        }
    }
    else
    {
        GetIniString("VICEPath",ccspath,sizeof(ccspath));
        if(!FILE(ccspath))
        {
            printf("Invalid %s setting, \"%s\" does not exist\r\n","VICEPath",ccspath);
            return 1;
        }
    }
}
if(!FILE(argv[2]))
{
    printf("%s not found\r\n",argv[2]);
    return 1;
}
printf(" Preparing %s\r\n",imgname);
if(gendisk()!=0)
{
    printf("error writing d64 file\r\n");
    return 1;
}
printf(" Injecting %s \r\n",packers[selectedpacker].desc);
myargv[1]=imgname;
myargv[2]=packers[selectedpacker].ID  ;
myargv[3]=packers[selectedpacker].filename;
if(p2d(4,myargv)!=0) return 1;
printf(" Injecting %s as \"1\"\r\n",argv[2]);
myargv[1]=imgname;
myargv[2]="1"  ;
myargv[3]=argv[2];
if(p2d(4,myargv)!=0) return 1;

//printf("%s\r\n",ccspath);
GetCurrentDirectory( _MAX_PATH, curdir );
if(*emutype=='C')
{
    strcpy(execstr,"\"");
    strcat(execstr,ccspath);
    strcat(execstr,"\"");
    strcat(execstr," -window -cfg \"");
    strcat(execstr,cfgpath);
    strcat(execstr,"\" -autorun \"");
    strcat(execstr,curdir);
    strcat(execstr,"\\");
    strcat(execstr,imgname);
    strcat(execstr,"\",nsu");
    p=NULL;
}
else
{
    strcpy(execstr," -warp +saveres +confirmexit +sound +iecdevice8 +cart ");
    strcat(execstr,(packers[selectedpacker].TrueDriveNeeded)?"-":"+");
    strcat(execstr,"truedrive");
    strcat(execstr," ");
    strcat(execstr,(packers[selectedpacker].TrueDriveNeeded)?"+":"-");
    strcat(execstr,"virtualdev");
    strcat(execstr," -autostart \"");
    strcat(execstr,curdir);
    strcat(execstr,"\\");
    strcat(execstr,imgname);
    strcat(execstr,"\"");
    p = ccspath;
}
printf(" Executing:\r\nProgram=%s\r\nCmdline=%s\r\nPress Alt-X in %s to continue\r\n"
       ,p,
       execstr,
       (*emutype=='C'?"CCS":"VICE")
      );

memset(&StartupInfo,0,sizeof(StartupInfo));
StartupInfo.cb = sizeof(StartupInfo);
memset(&procinfo,0,sizeof(procinfo));

if(! CreateProcess( p, execstr, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &StartupInfo, &procinfo ) )
{
    printf("CreateProcess failed\r\n");
    return 1;
}
else
{
    while(WaitForSingleObject(procinfo.hProcess,1000)!=0)
        ;
    CloseHandle(procinfo.hThread);
    CloseHandle(procinfo.hProcess);
}
printf(" Extracting \"2\" as %s \r\n",argv[3]);
myargv[1]=imgname;
myargv[2]="2"  ;
myargv[3]=argv[3];
if(d2p(4,myargv)!=0) return 1;

DeleteFile(imgname);
DeleteFile(packers[selectedpacker].filename);
printf(" patching startaddress at offset 0x%04x\r\n",packers[selectedpacker].patchoffs);
hdisk=fopen(argv[3],"r+b");
if(hdisk)
{
    if( packers[selectedpacker].patchoffs >= 0 )
        fseek( hdisk,packers[selectedpacker].patchoffs,SEEK_SET);
    else
        fseek( hdisk,packers[selectedpacker].patchoffs,SEEK_END);
    nbytes=c64Str2int(argv[4]);
    fwrite((char *)&nbytes,1,2,hdisk);
    fclose(hdisk);
    printf(" Done.\r\n");
}
else
{
    printf("What?! can't open %s for patching offset 0x%04x\r\n",argv[3],packers[selectedpacker].patchoffs);
    return 2;
}
return 0;
}
